]> git.ipfire.org Git - people/ms/u-boot.git/blame - MAKEALL
microblaze: Setup MB vectors if feature is enable for u-boot
[people/ms/u-boot.git] / MAKEALL
CommitLineData
f2352877 1#!/bin/bash
0777eafb
WD
2# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
0777eafb 5
d8e392d9
MF
6usage()
7{
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -h, --help This help output
20
21 Selections by these options are logically ANDed; if the same option
22 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
23 will select all configurations where the vendor is either FOO or
24 BAR. Any additional arguments specified on the command line are
25 always build additionally. See the boards.cfg file for more info.
26
27 If no boards are specified, then the default is "powerpc".
28
29 Environment variables:
30 BUILD_NCPUS number of parallel make jobs (default: auto)
31 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
32 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
33 BUILD_DIR output build directory (default: ./)
34
35 Examples:
36 - build all Power Architecture boards:
37 MAKEALL -a powerpc
38 MAKEALL --arch powerpc
39 MAKEALL powerpc
40 - build all PowerPC boards manufactured by vendor "esd":
41 MAKEALL -a powerpc -v esd
42 - build all PowerPC boards manufactured either by "keymile" or "siemens":
43 MAKEALL -a powerpc -v keymile -v siemens
44 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
45 MAKEALL -c mpc83xx -v freescale 4xx
46 EOF
47 exit ${ret}
48}
49
50SHORT_OPTS="ha:c:v:s:"
51LONG_OPTS="help,arch:,cpu:,vendor:,soc:"
0777eafb
WD
52
53# Option processing based on util-linux-2.13/getopt-parse.bash
54
071bc923 55# Note that we use `"$@"' to let each command-line parameter expand to a
0777eafb
WD
56# separate word. The quotes around `$@' are essential!
57# We need TEMP as the `eval set --' would nuke the return value of
58# getopt.
59TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
60 -n 'MAKEALL' -- "$@"`
61
d8e392d9 62[ $? != 0 ] && usage 1
0777eafb
WD
63
64# Note the quotes around `$TEMP': they are essential!
65eval set -- "$TEMP"
66
67SELECTED=''
68
69while true ; do
70 case "$1" in
71 -a|--arch)
72 # echo "Option ARCH: argument \`$2'"
73 if [ "$opt_a" ] ; then
74 opt_a="${opt_a%)} || \$2 == \"$2\")"
75 else
76 opt_a="(\$2 == \"$2\")"
77 fi
78 SELECTED='y'
79 shift 2 ;;
80 -c|--cpu)
81 # echo "Option CPU: argument \`$2'"
82 if [ "$opt_c" ] ; then
83 opt_c="${opt_c%)} || \$3 == \"$2\")"
84 else
85 opt_c="(\$3 == \"$2\")"
86 fi
87 SELECTED='y'
88 shift 2 ;;
89 -s|--soc)
90 # echo "Option SoC: argument \`$2'"
91 if [ "$opt_s" ] ; then
92 opt_s="${opt_s%)} || \$6 == \"$2\")"
93 else
94 opt_s="(\$6 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -v|--vendor)
99 # echo "Option VENDOR: argument \`$2'"
100 if [ "$opt_v" ] ; then
101 opt_v="${opt_v%)} || \$5 == \"$2\")"
102 else
103 opt_v="(\$5 == \"$2\")"
104 fi
105 SELECTED='y'
106 shift 2 ;;
d8e392d9
MF
107 -h|--help)
108 usage ;;
0777eafb
WD
109 --)
110 shift ; break ;;
111 *)
112 echo "Internal error!" >&2 ; exit 1 ;;
113 esac
114done
115# echo "Remaining arguments:"
116# for arg do echo '--> '"\`$arg'" ; done
117
118FILTER="\$1 !~ /^#/"
119[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
120[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
121[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
122[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
123
124if [ "$SELECTED" ] ; then
125 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
cd57b0bb
PT
126
127 # Make sure some boards from boards.cfg are actually found
128 if [ -z "$SELECTED" ] ; then
129 echo "Error: No boards selected, invalid arguments"
130 exit 1
131 fi
0777eafb
WD
132fi
133
134#########################################################################
135
40a28f08
PT
136# Print statistics when we exit
137trap exit 1 2 3 15
138trap print_stats 0
139
7fa6a2f3
WD
140# Determine number of CPU cores if no default was set
141: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
142
143if [ "$BUILD_NCPUS" -gt 1 ]
144then
55f786d8 145 JOBS="-j $((BUILD_NCPUS + 1))"
7fa6a2f3
WD
146else
147 JOBS=""
148fi
149
a8c7c708 150
7ebf7443
WD
151if [ "${CROSS_COMPILE}" ] ; then
152 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
153else
154 MAKE=make
155fi
156
f9328639
MB
157if [ "${MAKEALL_LOGDIR}" ] ; then
158 LOG_DIR=${MAKEALL_LOGDIR}
159else
160 LOG_DIR="LOG"
161fi
887e2ec9 162
f9328639
MB
163if [ ! "${BUILD_DIR}" ] ; then
164 BUILD_DIR="."
165fi
166
4f0645eb 167[ -d ${LOG_DIR} ] || mkdir ${LOG_DIR} || exit 1
7ebf7443
WD
168
169LIST=""
170
40a28f08
PT
171# Keep track of the number of builds and errors
172ERR_CNT=0
173ERR_LIST=""
174TOTAL_CNT=0
f2352877 175RC=0
40a28f08 176
9ec49f8f
MF
177# Helper funcs for parsing boards.cfg
178boards_by_field()
179{
180 awk \
181 -v field="$1" \
182 -v select="$2" \
183 '($1 !~ /^#/ && $field == select) { print $1 }' \
184 boards.cfg
185}
186boards_by_arch() { boards_by_field 2 "$@" ; }
187boards_by_cpu() { boards_by_field 3 "$@" ; }
0a41edaa 188boards_by_soc() { boards_by_field 6 "$@" ; }
9ec49f8f 189
0db5bca8
WD
190#########################################################################
191## MPC5xx Systems
192#########################################################################
193
9ec49f8f 194LIST_5xx="$(boards_by_cpu mpc5xx)"
0db5bca8 195
945af8d7
WD
196#########################################################################
197## MPC5xxx Systems
198#########################################################################
199
2ae18241 200LIST_5xxx="$(boards_by_cpu mpc5xxx)"
945af8d7 201
8993e54b
RJ
202#########################################################################
203## MPC512x Systems
204#########################################################################
205
2ae18241 206LIST_512x="$(boards_by_cpu mpc512x)"
945af8d7 207
7ebf7443
WD
208#########################################################################
209## MPC8xx Systems
210#########################################################################
9ec49f8f 211
2ae18241 212LIST_8xx="$(boards_by_cpu mpc8xx)"
7ebf7443
WD
213
214#########################################################################
215## PPC4xx Systems
216#########################################################################
217
2ae18241 218LIST_4xx="$(boards_by_cpu ppc4xx)"
7ebf7443 219
983fda83
WD
220#########################################################################
221## MPC8220 Systems
222#########################################################################
223
9ec49f8f 224LIST_8220="$(boards_by_cpu mpc8220)"
983fda83 225
7ebf7443
WD
226#########################################################################
227## MPC824x Systems
228#########################################################################
229
2ae18241 230LIST_824x="$(boards_by_cpu mpc824x)"
592c5cab 231
7ebf7443 232#########################################################################
7aa78614 233## MPC8260 Systems (includes 8250, 8255 etc.)
7ebf7443
WD
234#########################################################################
235
2ae18241 236LIST_8260="$(boards_by_cpu mpc8260)"
7ebf7443 237
f046ccd1
EL
238#########################################################################
239## MPC83xx Systems (includes 8349, etc.)
240#########################################################################
241
2ae18241 242LIST_83xx="$(boards_by_cpu mpc83xx)"
f046ccd1 243
42d1f039
WD
244#########################################################################
245## MPC85xx Systems (includes 8540, 8560 etc.)
246#########################################################################
247
2ae18241 248LIST_85xx="$(boards_by_cpu mpc85xx)"
42d1f039 249
822d5536
JL
250#########################################################################
251## MPC86xx Systems
252#########################################################################
253
2ae18241 254LIST_86xx="$(boards_by_cpu mpc86xx)"
822d5536 255
7ebf7443
WD
256#########################################################################
257## 74xx/7xx Systems
258#########################################################################
259
2ae18241 260LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
7ebf7443 261
d9a42c0a
WD
262#########################################################################
263## PowerPC groups
264#########################################################################
265
266LIST_TSEC=" \
267 ${LIST_83xx} \
268 ${LIST_85xx} \
269 ${LIST_86xx} \
270"
271
a47a12be 272LIST_powerpc=" \
fb56579f 273 ${LIST_5xx} \
3deca9d4 274 ${LIST_512x} \
fb56579f
KP
275 ${LIST_5xxx} \
276 ${LIST_8xx} \
277 ${LIST_8220} \
278 ${LIST_824x} \
279 ${LIST_8260} \
280 ${LIST_83xx} \
281 ${LIST_85xx} \
282 ${LIST_86xx} \
283 ${LIST_4xx} \
2ae18241 284 ${LIST_74xx_7xx}\
fb56579f 285"
7ebf7443 286
a47a12be
SR
287# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
288# still using "ppc" instead of "powerpc"
289LIST_ppc=" \
290 ${LIST_powerpc} \
291"
292
7ebf7443
WD
293#########################################################################
294## StrongARM Systems
295#########################################################################
296
9ec49f8f 297LIST_SA="$(boards_by_cpu sa1100)"
7ebf7443 298
7ebf7443
WD
299#########################################################################
300## ARM9 Systems
301#########################################################################
302
6a8760d7
WD
303LIST_ARM9="$(boards_by_cpu arm920t) \
304 $(boards_by_cpu arm926ejs) \
305 $(boards_by_cpu arm925t) \
fb56579f
KP
306 omap1610h2 \
307 omap1610inn \
308 omap730p2 \
6f21347d 309"
7ebf7443 310
8ed96046
WD
311#########################################################################
312## ARM11 Systems
313#########################################################################
6a8760d7 314LIST_ARM11="$(boards_by_cpu arm1136) \
0c692673 315 apollon \
0c692673
GL
316 imx31_phycore \
317 imx31_phycore_eet \
8449f287 318 mx31pdk \
d08e5ca3 319 mx31pdk_nand \
0c692673 320 smdk6400 \
74f4304e 321"
8ed96046 322
f904cdbb 323#########################################################################
f56348af 324## ARMV7 Systems
f904cdbb 325#########################################################################
f37586bb
DB
326
327LIST_ARMV7="$(boards_by_cpu armv7)"
f904cdbb 328
602cac13
JCPV
329#########################################################################
330## AT91 Systems
331#########################################################################
332
5cfeec51 333LIST_at91="$(boards_by_soc at91)"
602cac13 334
7ebf7443
WD
335#########################################################################
336## Xscale Systems
337#########################################################################
338
7c957c0e 339LIST_pxa="$(boards_by_cpu pxa)"
7ebf7443 340
9ec49f8f 341LIST_ixp="$(boards_by_cpu ixp)
fb56579f
KP
342 pdnb3 \
343 scpu \
344"
7ebf7443 345
d9a42c0a
WD
346#########################################################################
347## ARM groups
348#########################################################################
2d5b561e 349
f904cdbb
DB
350LIST_arm=" \
351 ${LIST_SA} \
f904cdbb
DB
352 ${LIST_ARM9} \
353 ${LIST_ARM10} \
354 ${LIST_ARM11} \
f56348af 355 ${LIST_ARMV7} \
f904cdbb
DB
356 ${LIST_at91} \
357 ${LIST_pxa} \
358 ${LIST_ixp} \
8ed96046 359"
7ebf7443 360
c021880a 361#########################################################################
b62bdffb 362## MIPS Systems (default = big endian)
c021880a
WD
363#########################################################################
364
fb56579f
KP
365LIST_mips4kc=" \
366 incaip \
0764c164 367 qemu_mips \
2a61eff6
SR
368 vct_platinum \
369 vct_platinum_small \
370 vct_platinum_onenand \
371 vct_platinum_onenand_small \
372 vct_platinumavc \
373 vct_platinumavc_small \
374 vct_platinumavc_onenand \
375 vct_platinumavc_onenand_small \
376 vct_premium \
377 vct_premium_small \
378 vct_premium_onenand \
379 vct_premium_onenand_small \
fb56579f 380"
c021880a 381
b38a5699 382LIST_mips5kc=""
3e38691e 383
fb56579f
KP
384LIST_au1xx0=" \
385 dbau1000 \
386 dbau1100 \
387 dbau1500 \
388 dbau1550 \
389 dbau1550_el \
390 gth2 \
391"
5da627a4 392
fb56579f
KP
393LIST_mips=" \
394 ${LIST_mips4kc} \
395 ${LIST_mips5kc} \
396 ${LIST_au1xx0} \
397"
c021880a 398
b62bdffb
WD
399#########################################################################
400## MIPS Systems (little endian)
401#########################################################################
402
403LIST_mips4kc_el=""
404
405LIST_mips5kc_el=""
406
fb56579f
KP
407LIST_au1xx0_el=" \
408 dbau1550_el \
b09258c5 409 pb1000 \
fb56579f 410"
b62bdffb 411
fb56579f
KP
412LIST_mips_el=" \
413 ${LIST_mips4kc_el} \
414 ${LIST_mips5kc_el} \
415 ${LIST_au1xx0_el} \
416"
b62bdffb 417
7a8e9bed 418#########################################################################
fea25720 419## x86 Systems
7a8e9bed
WD
420#########################################################################
421
fea25720 422LIST_x86="$(boards_by_arch x86)"
7a8e9bed 423
5c952cf0
WD
424#########################################################################
425## Nios-II Systems
426#########################################################################
427
4827d067 428LIST_nios2="$(boards_by_arch nios2)"
5c952cf0 429
857cad37
WD
430#########################################################################
431## MicroBlaze Systems
432#########################################################################
433
9ec49f8f 434LIST_microblaze="$(boards_by_arch microblaze)"
857cad37 435
f8c3b4f3
ZL
436#########################################################################
437## ColdFire Systems
438#########################################################################
439
9ec49f8f 440LIST_coldfire="$(boards_by_arch m68k)
9d79e575 441 astro_mcf5373l \
fb56579f
KP
442 cobra5272 \
443 EB+MCF-EV123 \
444 EB+MCF-EV123_internal \
1552af70 445 M52277EVB \
4a442d31 446 M5235EVB \
aa5f1f9d
TL
447 M5329AFEE \
448 M5373EVB \
05316f8e 449 M54451EVB \
8ae158cd 450 M54455EVB \
57a12720
TL
451 M5475AFE \
452 M5485AFE \
9acb626f 453"
f8c3b4f3 454
6ccec449
WD
455#########################################################################
456## AVR32 Systems
457#########################################################################
458
9ec49f8f 459LIST_avr32="$(boards_by_arch avr32)"
6ccec449 460
ef26a08f
AL
461#########################################################################
462## Blackfin Systems
463#########################################################################
464
36cf8cb4 465LIST_blackfin="$(boards_by_arch blackfin)"
ef26a08f 466
c7144373
JCPV
467#########################################################################
468## SH Systems
469#########################################################################
470
e0f0e527 471LIST_sh2="$(boards_by_cpu sh2)"
3771c69d 472LIST_sh3="$(boards_by_cpu sh3)"
03626be3 473LIST_sh4="$(boards_by_cpu sh4)"
d9a42c0a 474
03626be3 475LIST_sh="$(boards_by_arch sh)"
c7144373 476
c2f02da2
DH
477#########################################################################
478## SPARC Systems
479#########################################################################
480
9ec49f8f 481LIST_sparc="$(boards_by_arch sparc)"
7ebf7443
WD
482
483#-----------------------------------------------------------------------
484
485build_target() {
486 target=$1
487
488 ${MAKE} distclean >/dev/null
d70d8ccc 489 ${MAKE} -s ${target}_config
f9328639
MB
490
491 ${MAKE} ${JOBS} all 2>&1 >${LOG_DIR}/$target.MAKELOG \
492 | tee ${LOG_DIR}/$target.ERR
f2352877
PT
493
494 # Check for 'make' errors
495 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
496 RC=1
497 fi
498
40a28f08
PT
499 if [ -s ${LOG_DIR}/$target.ERR ] ; then
500 ERR_CNT=$((ERR_CNT + 1))
501 ERR_LIST="${ERR_LIST} $target"
502 else
503 rm ${LOG_DIR}/$target.ERR
504 fi
505
506 TOTAL_CNT=$((TOTAL_CNT + 1))
f9328639 507
208447f8 508 ${CROSS_COMPILE}size ${BUILD_DIR}/u-boot \
f9328639 509 | tee -a ${LOG_DIR}/$target.MAKELOG
7ebf7443 510}
9ec49f8f
MF
511build_targets() {
512 for t in "$@" ; do
513 # If a LIST_xxx var exists, use it. But avoid variable
514 # expansion in the eval when a board name contains certain
515 # characters that the shell interprets.
516 case ${t} in
517 *[-+=]*) list= ;;
518 *) list=$(eval echo '${LIST_'$t'}') ;;
519 esac
520 if [ -n "${list}" ] ; then
521 build_targets ${list}
522 else
523 build_target ${t}
524 fi
525 done
526}
7ebf7443
WD
527
528#-----------------------------------------------------------------------
529
40a28f08
PT
530print_stats() {
531 echo ""
532 echo "--------------------- SUMMARY ----------------------------"
533 echo "Boards compiled: ${TOTAL_CNT}"
534 if [ ${ERR_CNT} -gt 0 ] ; then
535 echo "Boards with warnings or errors: ${ERR_CNT} (${ERR_LIST} )"
536 fi
537 echo "----------------------------------------------------------"
f2352877
PT
538
539 exit $RC
40a28f08 540}
7ebf7443 541
40a28f08 542#-----------------------------------------------------------------------
9ec49f8f 543
0777eafb
WD
544# Build target groups selected by options, plus any command line args
545set -- ${SELECTED} "$@"
546# run PowerPC by default
9ec49f8f 547[ $# = 0 ] && set -- powerpc
9ec49f8f 548build_targets "$@"